//***********************************************************************
//		MonitorTest / AppWindow.h
//
//					Copyright (c) 2003 David Blumberg
//						davidblumberg@pixay.com
//					Published under the MIT license
//***********************************************************************

#ifndef APP_WINDOW_H
#define APP_WINDOW_H

#include <Button.h>
#include <Roster.h>
#include <String.h>
#include <View.h>
#include <Window.h>
#include "ColorView.h"
#include "ConvergenceView.h"
#include "GeometryView.h"
#include "MainView.h"
#include "MoireView.h"
#include "ReadabilityView.h"


class AppWindow : public BWindow
{
	public:
						AppWindow(BRect frame);
						~AppWindow();
		virtual bool 	QuitRequested();
		virtual void 	MessageReceived(BMessage *message);
		
		int				screenCount;
			
	private:
		ColorView		*fColorView;
		ConvergenceView	*fConvergenceView;
		GeometryView	*fGeometryView;
		MainView		*fMainView;
		MoireView		*fMoireView;
		ReadabilityView	*fReadabilityView;
		
		int32 			screen_id;
};

extern AppWindow *fAppWindow;

#endif // APP_WINDOW_H
