//***********************************************************************
//		MonitorTest / ColorView.cpp
//
//					Copyright (c) 2003 David Blumberg
//						davidblumberg@pixay.com
//					Published under the MIT license
//***********************************************************************

#include "AppWindow.h"
#include "ColorView.h"
#include "Const.h"


ColorView::ColorView(BRect frame, const char *name, uint32 resizingMode = B_FOLLOW_ALL, uint32 flags = B_WILL_DRAW)
		: BView(frame, name, resizingMode, flags)
{
	SetViewColor(0,0,0);
	screenRect = fScreen.Frame();
}

ColorView::~ColorView() {
}

void ColorView::Draw(BRect updateRect)
{
	if(fAppWindow->screenCount == 1)
	{
		SetHighColor(255,255,255);
		FillRect(screenRect);
	}
	else if(fAppWindow->screenCount == 2)
	{
		SetHighColor(255,0,0);
		FillRect(screenRect);
	}
	else if(fAppWindow->screenCount == 3)
	{
		SetHighColor(0,255,0);
		FillRect(screenRect);
	}
	else if(fAppWindow->screenCount == 4)
	{
		SetHighColor(0,0,255);
		FillRect(screenRect);
	}
	else if(fAppWindow->screenCount == 5)
	{
		SetHighColor(0,0,0);
		FillRect(screenRect);
		
		SetHighColor(255,255,255);
		BRect whiteBoxRect = fScreen.Frame();
		whiteBoxRect.left = whiteBoxRect.right / 2 - 33;
		whiteBoxRect.right = whiteBoxRect.right / 2 + 33;
		whiteBoxRect.top = whiteBoxRect.bottom / 2 - 33;
		whiteBoxRect.bottom = whiteBoxRect.bottom / 2 + 33;
		FillRect(whiteBoxRect);
	}
}

void ColorView::MouseDown(BPoint where)
{
	Window()->Activate();
	
	if(Window()->CurrentMessage()->FindInt32("buttons") == B_PRIMARY_MOUSE_BUTTON)
	{
		BMessage LeftClick(LEFT_CLICK);
		LeftClick.AddInt32("screen_id", 2);
		Window()->PostMessage(&LeftClick);
	}	
	else if(Window()->CurrentMessage()->FindInt32("buttons") == B_SECONDARY_MOUSE_BUTTON)
	{
		BMessage RightClick(RIGHT_CLICK);
		RightClick.AddInt32("screen_id", 2);
		Window()->PostMessage(&RightClick);
	}
}
