//***********************************************************************
//		MonitorTest / MainView.cpp
//
//					Copyright (c) 2003 David Blumberg
//						davidblumberg@pixay.com
//					Published under the MIT license
//***********************************************************************

#include "MainView.h"
#include "Const.h"


MainView::MainView(BRect frame, const char *name, uint32 resizingMode = B_FOLLOW_ALL, uint32 flags = B_WILL_DRAW)
		: BView(frame, name, resizingMode, flags)
{
	SetViewColor(0,0,0);
	
	screenRect = fScreen.Frame();
	if(screenRect.right == 1599)
	{
		ColorfadeBmp = BTranslationUtils::GetBitmap('PNG ', "Main_Colorfade_1600x1200.png");
		BrightnessBmp = BTranslationUtils::GetBitmap('PNG ', "Main_Brightness_1600x1200.png");
	}
	else if(screenRect.right == 1279)
	{
		ColorfadeBmp = BTranslationUtils::GetBitmap('PNG ', "Main_Colorfade_1280x1024.png");
		BrightnessBmp = BTranslationUtils::GetBitmap('PNG ', "Main_Brightness_1280x1024.png");
	}
	else if(screenRect.right == 1151)
	{
		ColorfadeBmp = BTranslationUtils::GetBitmap('PNG ', "Main_Colorfade_1152x864.png");
		BrightnessBmp = BTranslationUtils::GetBitmap('PNG ', "Main_Brightness_1152x864.png");
	}
	else if(screenRect.right == 1023)
	{
		ColorfadeBmp = BTranslationUtils::GetBitmap('PNG ', "Main_Colorfade_1024x768.png");
		BrightnessBmp = BTranslationUtils::GetBitmap('PNG ', "Main_Brightness_1024x768.png");
	}
		
	// Add Buttons
	BRect buttonRect(0.0, 0.0, 115.0, 0.0);
	
/*	GeometryBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 4), (screenRect.bottom / 12 * 8 + 4)), "Geometry", "Geometry", new BMessage(GEOMETRY));
	GeometryBtn->ResizeToPreferred();
	AddChild(GeometryBtn);
	ColorBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 84), (screenRect.bottom / 12 * 8 + 4)), "Color", "Color", new BMessage(COLOR));
	ColorBtn->ResizeToPreferred();
	AddChild(ColorBtn);
	FocusBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 164), (screenRect.bottom / 12 * 8 + 4)), "Focus", "Focus", new BMessage(FOCUS));
	FocusBtn->ResizeToPreferred();
	AddChild(FocusBtn);
	BrightContrastBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 244), (screenRect.bottom / 12 * 8 + 4)), "BrightContrast", "Brightness/Contrast", new BMessage(BRIGHT_CONTRAST));
	BrightContrastBtn->ResizeToPreferred();
//	BrightContrastBtn->SetToolTipText("Check brightness and contrast");
	AddChild(BrightContrastBtn);
	ConvergenceBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 366), (screenRect.bottom / 12 * 8 + 4)), "Convergence", "Convergence", new BMessage(CONVERGENCE));
	ConvergenceBtn->ResizeToPreferred();
	AddChild(ConvergenceBtn);
	
	ResolutionBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 4), (screenRect.bottom / 12 * 8 + 31)), "Resolution", "Resolution", new BMessage(RESOLUTION));
	ResolutionBtn->ResizeToPreferred();
	AddChild(ResolutionBtn);
	MoireBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 84), (screenRect.bottom / 12 * 8 + 31)), "Moire", "Moire", new BMessage(MOIRE));
	MoireBtn->ResizeToPreferred();
	AddChild(MoireBtn);
	ReadabilityBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 164), (screenRect.bottom / 12 * 8 + 31)), "Readability", "Readability", new BMessage(READABILITY));
	ReadabilityBtn->ResizeToPreferred();
	AddChild(ReadabilityBtn);
	JumpingBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 244), (screenRect.bottom / 12 * 8 + 31)), "Jumping", "Jumping", new BMessage(JUMPING));
	JumpingBtn->ResizeToPreferred();
	AddChild(JumpingBtn);
	SoundBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 4 + 324), (screenRect.bottom / 12 * 8 + 31)), "Sound", "Sound", new BMessage(SOUND));
	SoundBtn->ResizeToPreferred();
//	SoundBtn->SetToolTipText("Check left and right speakers");
	AddChild(SoundBtn);
	*/
	
	MediaBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 12 - 364), (screenRect.bottom / 12 * 10 - 38)), "Media", "Media", new BMessage(MEDIA));
	MediaBtn->ResizeToPreferred();
//	MediaBtn->SetToolTipText("Show the Media preferences panel");
	AddChild(MediaBtn);
	ScreenBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 12 - 284), (screenRect.bottom / 12 * 10 - 38)), "Screen", "Screen", new BMessage(SCREEN));
	ScreenBtn->ResizeToPreferred();
//	ScreenBtn->SetToolTipText("Show the Screen preferences panel");
	AddChild(ScreenBtn);
	AboutBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 12 - 164), (screenRect.bottom / 12 * 10 - 38)), "About", "About", new BMessage(B_ABOUT_REQUESTED));
	AboutBtn->ResizeToPreferred();
	AddChild(AboutBtn);
	QuitBtn = new BButton(buttonRect.OffsetToCopy((screenRect.right / 16 * 12 - 84), (screenRect.bottom / 12 * 10 - 38)), "Quit", "Quit", new BMessage(QUIT));
	QuitBtn->ResizeToPreferred();
	AddChild(QuitBtn);
	
	// Screens' Menu
	fPopUpMenu = new BPopUpMenu("Test Sections", false, false);
	
	fPopUpMenu->AddItem(new BMenuItem("Brightness & Contrast", new BMessage(BRIGHT_CONTRAST), 'B'));
	fPopUpMenu->AddItem(new BMenuItem("Color", new BMessage(COLOR), 'C'));
	fPopUpMenu->AddItem(new BMenuItem("Convergence", new BMessage(CONVERGENCE), 'E'));
	fPopUpMenu->AddItem(new BMenuItem("Focus", new BMessage(FOCUS), 'F'));
	fPopUpMenu->AddItem(new BMenuItem("Geometry", new BMessage(GEOMETRY), 'G'));
	fPopUpMenu->AddItem(new BMenuItem("Jumping", new BMessage(JUMPING), 'J'));
	fPopUpMenu->AddItem(new BMenuItem("Moire", new BMessage(MOIRE), 'M'));
	fPopUpMenu->AddItem(new BMenuItem("Readability", new BMessage(READABILITY), 'R'));
	fPopUpMenu->AddItem(new BMenuItem("Resolution", new BMessage(RESOLUTION), 'N'));
	fPopUpMenu->AddItem(new BMenuItem("Sound", new BMessage(SOUND), 'S'));
	
	fMenuBar = new BMenuBar(BRect((screenRect.right / 16 * 12 - 364), (screenRect.bottom / 12 * 10 - 70), (screenRect.right / 16 * 12 - 270), (screenRect.bottom / 12 * 10 - 50)), "Screens' MenuBar", B_FOLLOW_NONE, B_ITEMS_IN_ROW, false);
	fMenuBar->AddItem(fPopUpMenu);
	AddChild(fMenuBar);
	
	// Get resolution
	resolution.SetTo("");
	resolution << screenRect.right + 1;
	resolution << "x";
	resolution << screenRect.bottom + 1;
	resolution << " Pixels, ";
}

MainView::~MainView() {
}

void MainView::Draw(BRect updateRect)
{	
	SetHighColor(255,255,255);
		
	SetPenSize(1.0);
	
	// Draw frame
	StrokeRect(screenRect);
	
	// Draw x-axis pattern
	xCoord = screenRect.right / 16;
	xIncrease = xCoord;
	for(; xCoord < screenRect.right; xCoord += xIncrease)
	{
		StrokeLine(BPoint((xCoord), (screenRect.top)), BPoint((xCoord), (screenRect.bottom)));
	}
	
	// Draw y-axis pattern
	yCoord = screenRect.bottom / 12;
	yIncrease = yCoord;
	for(; yCoord < screenRect.bottom; yCoord += yIncrease)
	{
		StrokeLine(BPoint((screenRect.left), (yCoord)), BPoint((screenRect.right), (yCoord)));
	}
	
	// Draw center ellipse
	SetHighColor(255,128,0);
	BRect cEllipseRect = fScreen.Frame();
	cEllipseRect.left += ((cEllipseRect.right - cEllipseRect.bottom) / 2);
	cEllipseRect.right -= ((cEllipseRect.right - cEllipseRect.bottom) / 2);
	StrokeEllipse(cEllipseRect);
	
	// Draw lefttop ellipse
	BRect ltEllipseRect = fScreen.Frame();
	ltEllipseRect.right = (ltEllipseRect.left + (screenRect.right / 16 * 2));
	ltEllipseRect.bottom = (ltEllipseRect.top + (screenRect.bottom / 12 * 2));
	StrokeEllipse(ltEllipseRect);
	
	// Draw righttop ellipse
	BRect rtEllipseRect = fScreen.Frame();
	rtEllipseRect.left = (rtEllipseRect.right - (screenRect.right / 16 * 2));
	rtEllipseRect.bottom = (rtEllipseRect.top + (screenRect.bottom / 12 * 2));
	StrokeEllipse(rtEllipseRect);
	
	// Draw leftbottom ellipse
	BRect lbEllipseRect = fScreen.Frame();
	lbEllipseRect.right = (lbEllipseRect.left + (screenRect.right / 16 * 2));
	lbEllipseRect.top = (lbEllipseRect.bottom - (screenRect.bottom / 12 * 2));
	StrokeEllipse(lbEllipseRect);
	
	// Draw rightbottom ellipse
	BRect rbEllipseRect = fScreen.Frame();
	rbEllipseRect.left = (rbEllipseRect.right - (screenRect.right / 16 * 2));
	rbEllipseRect.top = (rbEllipseRect.bottom - (screenRect.bottom / 12 * 2));
	StrokeEllipse(rbEllipseRect);
	
	//----------------------------------------------------------------------
	
	// Draw title
	SetHighColor(0,0,0);
	BRect titlebgRect = fScreen.Frame();
	titlebgRect.InsetBy((screenRect.right / 16 * 6 + 1), 0.0);
	titlebgRect.top += (screenRect.bottom / 12 + 1);
	titlebgRect.bottom -= (screenRect.bottom / 12 * 10 + 1);
	FillRect(titlebgRect);
	
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetFont(be_plain_font);
	SetFontSize(26.0);
	title.SetTo("MonitorTest");
	MovePenTo(BPoint((screenRect.right / 16 * 8 - (be_plain_font->StringWidth(title.String()) / 2) - 43), (screenRect.bottom / 12 + (screenRect.bottom / 12 / 2 + 13.5))));
	DrawString(title.String());
	
	//----------------------------------------------------------------------
	
	// Draw colors background
	SetHighColor(0,0,0);
	BRect colorsbgRect = fScreen.Frame();
	colorsbgRect.InsetBy((screenRect.right / 16 * 4 + 1), 0.0);
	colorsbgRect.top += (screenRect.bottom / 12 * 2 + 1);
	colorsbgRect.bottom -= (screenRect.bottom / 12 * 8 + 1);
	FillRect(colorsbgRect);
	
	// Blue
	SetHighColor(0,0,255);
	colorRect = fScreen.Frame();
	colorRect.left += (screenRect.right / 16 * 4 + 4);
	colorRect.top += (screenRect.bottom / 12 * 2 + 4);
	colorRect.right -= (screenRect.right / 16 * 11 + 3);
	colorRect.bottom -= (screenRect.bottom / 12 * 8 + 4);
	FillRect(colorRect);
	
	// Cyan
	SetHighColor(0,255,255);
	colorRect = fScreen.Frame();
	colorRect.left += (screenRect.right / 16 * 5 + 3);
	colorRect.top += (screenRect.bottom / 12 * 2 + 4);
	colorRect.right -= (screenRect.right / 16 * 10 + 3);
	colorRect.bottom -= (screenRect.bottom / 12 * 8 + 4);
	FillRect(colorRect);
	
	// Magenta
	SetHighColor(255,0,255);
	colorRect = fScreen.Frame();
	colorRect.left += (screenRect.right / 16 * 6 + 3);
	colorRect.top += (screenRect.bottom / 12 * 2 + 4);
	colorRect.right -= (screenRect.right / 16 * 9 + 3);
	colorRect.bottom -= (screenRect.bottom / 12 * 8 + 4);
	FillRect(colorRect);
	
	// Pink
	SetHighColor(255,0,128);
	colorRect = fScreen.Frame();
	colorRect.left += (screenRect.right / 16 * 7 + 3);
	colorRect.top += (screenRect.bottom / 12 * 2 + 4);
	colorRect.right -= (screenRect.right / 16 * 8 + 3);
	colorRect.bottom -= (screenRect.bottom / 12 * 8 + 4);
	FillRect(colorRect);
	
	// Red
	SetHighColor(255,0,0);
	colorRect = fScreen.Frame();
	colorRect.left += (screenRect.right / 16 * 8 + 3);
	colorRect.top += (screenRect.bottom / 12 * 2 + 4);
	colorRect.right -= (screenRect.right / 16 * 7 + 3);
	colorRect.bottom -= (screenRect.bottom / 12 * 8 + 4);
	FillRect(colorRect);
	
	// Orange
	SetHighColor(255,128,0);
	colorRect = fScreen.Frame();
	colorRect.left += (screenRect.right / 16 * 9 + 3);
	colorRect.top += (screenRect.bottom / 12 * 2 + 4);
	colorRect.right -= (screenRect.right / 16 * 6 + 3);
	colorRect.bottom -= (screenRect.bottom / 12 * 8 + 4);
	FillRect(colorRect);
	
	// Yellow
	SetHighColor(255,255,0);
	colorRect = fScreen.Frame();
	colorRect.left += (screenRect.right / 16 * 10 + 3);
	colorRect.top += (screenRect.bottom / 12 * 2 + 4);
	colorRect.right -= (screenRect.right / 16 * 5 + 3);
	colorRect.bottom -= (screenRect.bottom / 12 * 8 + 4);
	FillRect(colorRect);
	
	// Green
	SetHighColor(0,255,0);
	colorRect = fScreen.Frame();
	colorRect.left += (screenRect.right / 16 * 11 + 3);
	colorRect.top += (screenRect.bottom / 12 * 2 + 4);
	colorRect.right -= (screenRect.right / 16 * 4 + 3);
	colorRect.bottom -= (screenRect.bottom / 12 * 8 + 4);
	FillRect(colorRect);
	
	//----------------------------------------------------------------------
	
	// Draw colorfade background
	SetHighColor(0,0,0);
	BRect colorfadebgRect = fScreen.Frame();
	colorfadebgRect.InsetBy((screenRect.right / 16 * 2 + 1), 0.0);
	colorfadebgRect.top += (screenRect.bottom / 12 * 4 + 1);
	colorfadebgRect.bottom -= (screenRect.bottom / 12 * 6 + 1);
	FillRect(colorfadebgRect);
	
	if(ColorfadeBmp != 0)
		DrawBitmap(ColorfadeBmp, BPoint((screenRect.right / 16 * 2.5), (screenRect.bottom / 12 * 4 + 5)));
	
	//----------------------------------------------------------------------
	
	// Draw brightness background
	BRect brightnessbgRect = fScreen.Frame();
	brightnessbgRect.InsetBy((screenRect.right / 16 * 2 + 1), 0.0);
	brightnessbgRect.top += (screenRect.bottom / 12 * 6 + 1);
	brightnessbgRect.bottom -= (screenRect.bottom / 12 * 4 + 1);
	FillRect(brightnessbgRect);
	
	if(BrightnessBmp != 0)
		DrawBitmap(BrightnessBmp, BPoint((screenRect.right / 16 * 2.5), (screenRect.bottom / 12 * 6 + 6)));
	
	//----------------------------------------------------------------------
	
	// Draw button area background
	BRect buttonbgRect = fScreen.Frame();
	buttonbgRect.InsetBy((screenRect.right / 16 * 4 + 1), 0.0);
	buttonbgRect.top += (screenRect.bottom / 12 * 8 + 1);
	buttonbgRect.bottom -= (screenRect.bottom / 12 * 2 + 1);
	FillRect(buttonbgRect);
		
	// Draw resolution info background
	BRect resolutionbgRect = fScreen.Frame();
	resolutionbgRect.InsetBy((screenRect.right / 16 * 6 + 1), 0.0);
	resolutionbgRect.top += (screenRect.bottom / 12 * 10 + 1);
	resolutionbgRect.bottom -= (screenRect.bottom / 12 + 1);
	FillRect(resolutionbgRect);
	
	// Get color space
	colorSpace.SetTo("");
	if(fScreen.ColorSpace() == B_CMAP8)
		colorSpace << "8 bit Color";
	else if(fScreen.ColorSpace() == B_RGB15)
		colorSpace << "15 bit Color";
	else if(fScreen.ColorSpace() == B_RGB16)
		colorSpace << "16 bit Color";
	else if(fScreen.ColorSpace() == B_RGB32)
		colorSpace << "32 bit Color";
	else
		colorSpace << "monocrome";
	
	resolutionInfo.SetTo("");
	resolutionInfo << resolution.String();
	resolutionInfo << colorSpace.String();
	resolutionInfo.RemoveAll(".00");
	
	// Draw resolution information
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetFont(be_plain_font);
	SetFontSize(12.0);
	MovePenTo(BPoint((screenRect.right / 16 * 8 - (be_plain_font->StringWidth(resolutionInfo.String()) / 2) - 10), (screenRect.bottom / 12 * 10 + (screenRect.bottom / 12 / 2 + 6))));
	DrawString(resolutionInfo.String());
}

void MainView::MouseDown(BPoint where)
{
	Window()->Activate();
	
	/* Change color of title at click */
	if(Window()->CurrentMessage()->FindInt32("buttons") == B_PRIMARY_MOUSE_BUTTON || B_SECONDARY_MOUSE_BUTTON)
	{
		if(where.x >= (screenRect.right / 16 * 8 - (be_plain_font->StringWidth(title.String()) / 2) - 48) && where.x <= (screenRect.right / 16 * 8 + (be_plain_font->StringWidth(title.String()) / 2) + 43))
		{
			if(where.y >= (screenRect.bottom / 12 + (screenRect.bottom / 12 / 2 - 13.5)) && where.y <= (screenRect.bottom / 12 + (screenRect.bottom / 12 / 2 + 18)))
			{
				SetHighColor(84,108,255);
				SetLowColor(0,0,0);
				SetFont(be_plain_font);
				SetFontSize(26.0);
				MovePenTo(BPoint((screenRect.right / 16 * 8 - (be_plain_font->StringWidth(title.String()) / 2) - 43), (screenRect.bottom / 12 + (screenRect.bottom / 12 / 2 + 13.5))));
				DrawString(title.String());
			}
		}
	}
}

void MainView::MouseUp(BPoint where)
{
	Window()->Activate();
	
	/* Make the title a clickable url */
	char *args[] = {(char *)"http://beos.pixay.com/monitortest.php"};
	
	if(Window()->CurrentMessage()->FindInt32("buttons") == B_PRIMARY_MOUSE_BUTTON || B_SECONDARY_MOUSE_BUTTON)
	{
		if(where.x >= (screenRect.right / 16 * 8 - (be_plain_font->StringWidth(title.String()) / 2) - 48) && where.x <= (screenRect.right / 16 * 8 + (be_plain_font->StringWidth(title.String()) / 2) + 43))
		{
			if(where.y >= (screenRect.bottom / 12 + (screenRect.bottom / 12 / 2 - 13.5)) && where.y <= (screenRect.bottom / 12 + (screenRect.bottom / 12 / 2 + 18)))
			{
				be_roster->Launch("text/html", 1, args);
			}
		}
	}
	
	/* Restore original title color */
	SetHighColor(255,255,255);
	SetLowColor(0,0,0);
	SetFont(be_plain_font);
	SetFontSize(26.0);
	MovePenTo(BPoint((screenRect.right / 16 * 8 - (be_plain_font->StringWidth(title.String()) / 2) - 43), (screenRect.bottom / 12 + (screenRect.bottom / 12 / 2 + 13.5))));
	DrawString(title.String());
}
