//***********************************************************************
//		MonitorTest / MainView.h
//
//					Copyright (c) 2003 David Blumberg
//						davidblumberg@pixay.com
//					Published under the MIT license
//***********************************************************************

#ifndef MAIN_VIEW_H
#define MAIN_VIEW_H

#include <Alert.h>
#include <Application.h>
#include <Bitmap.h>
#include <Button.h>
#include <MenuBar.h>
#include <MenuField.h>
#include <MenuItem.h>
#include <PopUpMenu.h>
#include <Roster.h>
#include <Screen.h>
#include <String.h>
#include <TranslationUtils.h>
#include <View.h>


class MainView : public BView
{
	public:
						MainView(BRect frame, const char *name, uint32 resizingMode = B_FOLLOW_ALL, uint32 flags = B_WILL_DRAW);
						~MainView();
		virtual void	Draw(BRect updateRect);
		void			MouseDown(BPoint where);
		void			MouseUp(BPoint where);
	
	private:
		BBitmap			*ColorfadeBmp;
		BBitmap			*BrightnessBmp;
		
		BButton			*GeometryBtn;
		BButton			*BrightContrastBtn;
		BButton			*ColorBtn;
		BButton			*AboutBtn;
		BButton			*ConvergenceBtn;
		BButton			*FocusBtn;
		BButton			*ResolutionBtn;
		BButton			*MediaBtn;
		BButton			*MoireBtn;
		BButton			*ReadabilityBtn;
		BButton			*JumpingBtn;
		BButton			*SoundBtn;
		BButton			*ScreenBtn;
		BButton			*QuitBtn;
		
		BMenuBar		*fMenuBar;
		BMenuField		*fMenuField;
		BPopUpMenu		*fPopUpMenu;
		
		BRect			screenRect;
		BRect 			colorRect;
		
		BScreen			fScreen;
		
		BString			resolution;
		BString			colorSpace;
		BString			resolutionInfo;
		BString 		title;
		
		float 			xCoord;
		float 			yCoord;
		float 			xIncrease;
		float 			yIncrease;
};

#endif // MAIN_VIEW_H
