//***********************************************************************
//		MonitorTest / MoireView.cpp
//
//					Copyright (c) 2003 David Blumberg
//						davidblumberg@pixay.com
//					Published under the MIT license
//***********************************************************************

#include "AppWindow.h"
#include "MoireView.h"
#include "Const.h"


MoireView::MoireView(BRect frame, const char *name, uint32 resizingMode = B_FOLLOW_ALL, uint32 flags = B_WILL_DRAW)
		: BView(frame, name, resizingMode, flags)
{
	SetViewColor(0,0,0);
	screenRect = fScreen.Frame();
}

MoireView::~MoireView() {
}

void MoireView::Draw(BRect updateRect)
{
	if(fAppWindow->screenCount == 1)
	{
		SetHighColor(129,129,129);
		FillRect(screenRect);
	}
	else if(fAppWindow->screenCount == 2)
	{
		SetHighColor(161,161,161);
		FillRect(screenRect);
	}
	else if(fAppWindow->screenCount == 3)
	{
		pattern verticalLines = {0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa};
		SetHighColor(255,255,255);
		SetLowColor(0,0,0);
		FillRect(screenRect, verticalLines);
	}
	else if(fAppWindow->screenCount == 4)
	{
		pattern horizontalLines = {0xff, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 0x00};
		SetHighColor(255,255,255);
		SetLowColor(0,0,0);
		FillRect(screenRect, horizontalLines);
	}
	else if(fAppWindow->screenCount == 5)
	{
		pattern doubleCheckers = {0xcc, 0xcc, 0x33, 0x33, 0xcc, 0xcc, 0x33, 0x33};
		SetHighColor(255,255,255);
		SetLowColor(0,0,0);
		FillRect(screenRect, doubleCheckers);
	}
	else if(fAppWindow->screenCount == 6)
	{
		pattern checkers = {0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55};
		SetHighColor(255,255,255);
		SetLowColor(0,0,0);
		FillRect(screenRect, checkers);
	}
}

void MoireView::MouseDown(BPoint where)
{
	Window()->Activate();
	
	if(Window()->CurrentMessage()->FindInt32("buttons") == B_PRIMARY_MOUSE_BUTTON)
	{
		BMessage LeftClick(LEFT_CLICK);
		LeftClick.AddInt32("screen_id", 3);
		Window()->PostMessage(&LeftClick);
	}	
	else if(Window()->CurrentMessage()->FindInt32("buttons") == B_SECONDARY_MOUSE_BUTTON)
	{
		BMessage RightClick(RIGHT_CLICK);
		RightClick.AddInt32("screen_id", 3);
		Window()->PostMessage(&RightClick);
	}
}
