//***********************************************************************
//		MonitorTest / ReadabilityView.cpp
//
//					Copyright (c) 2003 David Blumberg
//						davidblumberg@pixay.com
//					Published under the MIT license
//***********************************************************************

#include "AppWindow.h"
#include "ReadabilityView.h"
#include "Const.h"


ReadabilityView::ReadabilityView(BRect frame, const char *name, uint32 resizingMode = B_FOLLOW_ALL, uint32 flags = B_WILL_DRAW)
		: BView(frame, name, resizingMode, flags)
{
	SetViewColor(0,0,0);
	screenRect = fScreen.Frame();
	
	font = new BFont(be_plain_font);
	font->SetSize(14.0);
//	font->SetFlags(B_DISABLE_ANTIALIASING);
	SetFont(font);
}

ReadabilityView::~ReadabilityView() {
}

void ReadabilityView::Draw(BRect updateRect)
{
	if(fAppWindow->screenCount == 1)
	{
		SetHighColor(255,255,255);
		FillRect(screenRect);
		
		SetPenSize(1.0);
		SetHighColor(0,0,0);
		SetLowColor(255,255,255);
		
		for(float line = 13.0; line < 1212.0; line += 16.0)
		{
			MovePenTo(BPoint(0.0, line));
			DrawString(READABILITY_TEXT);
		}
	}
	else if(fAppWindow->screenCount == 2)
	{
		SetHighColor(0,0,0);
		FillRect(screenRect);
		
		SetPenSize(1.0);
		SetHighColor(255,255,255);
		SetLowColor(0,0,0);
		
		for(float line = 13.0; line < 1212.0; line += 16.0)
		{
			MovePenTo(BPoint(0.0, line));
			DrawString(READABILITY_TEXT);
		}
	}
}

void ReadabilityView::MouseDown(BPoint where)
{
	Window()->Activate();
	
	if(Window()->CurrentMessage()->FindInt32("buttons") == B_PRIMARY_MOUSE_BUTTON)
	{
		BMessage LeftClick(LEFT_CLICK);
		LeftClick.AddInt32("screen_id", 5);
		Window()->PostMessage(&LeftClick);
	}	
	else if(Window()->CurrentMessage()->FindInt32("buttons") == B_SECONDARY_MOUSE_BUTTON)
	{
		BMessage RightClick(RIGHT_CLICK);
		RightClick.AddInt32("screen_id", 5);
		Window()->PostMessage(&RightClick);
	}
}
